const unitMap = {
    year: "y" /* Unit.year */,
    month: "M" /* Unit.month */,
    week: "w" /* Unit.week */,
    date: "d" /* Unit.day */,
    day: "d" /* Unit.day */,
    hour: "h" /* Unit.hour */,
    minute: "m" /* Unit.minute */,
    second: "s" /* Unit.second */,
    millisecond: "ms" /* Unit.millisecond */,
};
Object.keys(unitMap).forEach((key) => {
    const s = (key + "s");
    const v = unitMap[key];
    unitMap[s] = unitMap[v] = unitMap[key];
});
export const getUnitShort = (unit) => {
    const u = unitMap[(unit || "ms" /* Unit.millisecond */)] ||
        unitMap[String(unit).toLowerCase()];
    if (!u)
        throw new RangeError("Invalid unit: " + unit);
    return u;
};
export const unitMS = {
    h: 3600000 /* d.HOUR */,
    m: 60000 /* d.MINUTE */,
    s: 1000 /* d.SECOND */,
    ms: 1,
};
