import { getTZF } from "./tzf.js";
import { DateUTC } from "./dateutc.js";
class DateTZ extends DateUTC {
    constructor(dt, timezone) {
        const t = +dt;
        const tzf = getTZF(timezone);
        const tzo = tzf(t);
        super(new Date(t + tzo * 60000 /* d.MINUTE */));
        this.t = t;
        this.tzf = tzf;
        this.tzo = tzo;
    }
    valueOf() {
        return this.t;
    }
    setTime(msec) {
        const tzo = this.tzo = this.tzf(msec);
        this.dt.setTime(+msec + tzo * 60000 /* d.MINUTE */);
        return this.t = msec;
    }
    getTimezoneOffset() {
        return -this.tzo;
    }
}
export const tzPlugin = (Parent) => {
    return class CDateTZ extends Parent {
        tz(timezone) {
            const out = this.inherit();
            out.x.rw = (dt) => new DateTZ(new Date(+dt), timezone);
            return out;
        }
    };
};
